package com.company.indexbugsoftdelete.entity

import io.jmix.core.metamodel.annotation.JmixEntity
import java.util.*
import javax.persistence.*
import javax.validation.constraints.NotNull


@JmixEntity
@MappedSuperclass
abstract class BaseComment<T : BaseEntity> : BaseEntity() {
    @Column(name = "COMMENT_", nullable = false)
    @Lob
    @NotNull
    open var comment: String? = null

    @NotNull
    @Column(name = "DATE_", nullable = false)
    @Temporal(TemporalType.DATE)
    open var date: Date? = null

    @JoinColumn(name = "USER_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    open var user: User? = null
}
