package com.company.indexbugsoftdelete.entity

import io.jmix.core.entity.annotation.JmixGeneratedValue
import io.jmix.core.metamodel.annotation.JmixEntity
import org.springframework.data.annotation.CreatedBy
import org.springframework.data.annotation.CreatedDate
import org.springframework.data.annotation.LastModifiedBy
import org.springframework.data.annotation.LastModifiedDate
import java.util.*
import javax.persistence.*


@JmixEntity
@MappedSuperclass
abstract class BaseEntity {
    companion object {
        val BASE_ENTITY_CONTENT_IGNORED_FIELDS_REGEX = listOf(
                // no content data in traits fields
                "^(.*\\.)?version$",
                "^(.*\\.)?createdBy$",
                "^(.*\\.)?createdDate$",
                "^(.*\\.)?lastModifiedBy$",
                "^(.*\\.)?lastModifiedDate$",
                "^(.*\\.)?deletedBy$",
                "^(.*\\.)?deletedDate$",
                // no content data in private jmix fields
                "^(.*\\.)?_jmixEntityEntry\\..*",
                "^(.*\\.)?_persistence_.*",
                // stop recursivity in JTS Geometry envelope.envelope…
                "^.*\\.envelope\\.envelope\\..*"
        )
        const val ID = "id"
        // ignore parent fields.
        // ALL FIELDS POINTING TO A PARENT RELATION SHOULD BE PREFIXED BY 'parentField...'
        const val PARENT_FIELD_REGEX = "^(.*\\.)?parentField.*$"
    }
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    var id: UUID? = null

    @Column(name = "VERSION", nullable = false)
    @Version
    var version: Int? = null

    @CreatedBy
    @Column(name = "CREATED_BY")
    var createdBy: String? = null

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    var createdDate: Date? = null

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    var lastModifiedBy: String? = null

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    var lastModifiedDate: Date? = null
}
