package com.company.indexbugsoftdelete.entity

import io.jmix.core.annotation.DeletedBy
import io.jmix.core.annotation.DeletedDate
import io.jmix.core.metamodel.annotation.JmixEntity
import java.util.*
import javax.persistence.Column
import javax.persistence.MappedSuperclass
import javax.persistence.Temporal
import javax.persistence.TemporalType

interface BaseSoftDelete {
    var deletedBy: String?
    var deletedDate: Date?
}

@JmixEntity
@MappedSuperclass
abstract class BaseEntitySoftDelete : BaseEntity(), BaseSoftDelete {
    @DeletedBy
    @Column(name = "DELETED_BY")
    override var deletedBy: String? = null

    @DeletedDate
    @Column(name = "DELETED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    override var deletedDate: Date? = null
}
