package com.company.indexbugsoftdelete.entity

import io.jmix.core.metamodel.annotation.JmixEntity
import javax.persistence.*
import javax.validation.constraints.NotNull

@JmixEntity
@Table(name = "COM_LINK", uniqueConstraints = [
    UniqueConstraint(name = "IDX_COM_LINK_UNQ", columnNames = ["CODE", "SEARCH_KEY"]),
    UniqueConstraint(name = "IDX_COM_LINK_UNQ_1", columnNames = ["NAME", "SEARCH_KEY"])
])
@Entity(name = "com_Link")
open class Link : BaseMasterData(), BaseMenuItem {

    @NotNull
    @Column(name = "URL")
    var url: String? = null

    @Column(name = "ICON")
    override var icon: String?= null

    @Column(name = "INSERTION_MENU_ID")
    override var insertionMenuId: String? = null

    @Column(name = "INSERTION_MODE")
    override var insertionMode: MenuInsertionMode? = null

    @Column(name = "STYLENAME")
    override var styleName: String? = null

    @Column(name = "VISIBLE")
    override var visible: Boolean? = null

}
