package com.company.indexbugsoftdelete.entity

import io.jmix.core.metamodel.annotation.JmixEntity
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.Table
import javax.persistence.UniqueConstraint
import javax.validation.constraints.NotNull

@JmixEntity
@Table(name = "COM_SEARCH_KEY", uniqueConstraints = [
    UniqueConstraint(name = "IDX_COM_SEARCH_KEY_UNQ", columnNames = ["SEARCH_KEY", "MASTER_DATA"])
])
@Entity(name = "com_SearchKey")
open class SearchKey : BaseEntity() {
    @NotNull
    @Column(name = "SEARCH_KEY", nullable = false)
    @Suppress("MemberNameEqualsClassName")
    var searchKey: String? = null

    @Column(name = "MASTER_DATA", nullable = false)
    @NotNull
    var masterData: String? = null

    @Column(name = "DEFAULT_MIN")
    var defaultMin: String? = null

    @Column(name = "DEFAULT_MAX")
    var defaultMax: String? = null
}
